// BonSrcDecoder1seg.h: CBonSrcDecoder1seg NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "IBonDriver.h"
#include "IBonDriver2.h"


/////////////////////////////////////////////////////////////////////////////
// Bon\[XfR[_(`[iTSXg[M)
/////////////////////////////////////////////////////////////////////////////
// Output	#0	: CMediaData		TSXg[
/////////////////////////////////////////////////////////////////////////////

class CBonSrcDecoder1seg : public CMediaDecoder
{
public:
	// G[R[h
	enum {
		ERR_NOERROR,		// G[Ȃ
		ERR_DRIVER,			// hCoG[
		ERR_TUNEROPEN,		// `[iI[vG[
		ERR_TUNER,			// `[iG[
		ERR_NOTOPEN,		// `[iJĂȂ
		ERR_ALREADYOPEN,	// `[iɊJĂ
		ERR_NOTPLAYING,		// ĐĂȂ
		ERR_ALREADYPLAYING,	// ɍĐĂ
		ERR_TIMEOUT,		// ^CAEg
		ERR_INTERNAL		// G[
	};
	CBonSrcDecoder1seg( IEventHandler *pEventHandler = NULL );
	virtual ~CBonSrcDecoder1seg();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CBonSrcDecoder1seg
	const bool OpenTuner( IBonDriver* t_piBonDriver );
	const bool CloseTuner(void);
	const bool IsOpen() const;

	const bool Play(void);
	const bool Stop(void);

private:
//	static DWORD WINAPI StreamRecvThread(LPVOID pParam);
	static UINT32 WINAPI StreamRecvThread(LPVOID pParam);
	void OnTsStream(BYTE *pStreamData, DWORD dwStreamSize);
	bool PauseStreamRecieve(DWORD TimeOut = 4000);
	bool ResumeStreamRecieve(DWORD TimeOut = 4000);

	IBonDriver *m_piBonDriver;
	IBonDriver2 *m_piBonDriver2;	
	HANDLE m_hStreamRecvThread;
	CLocalEvent m_cPauseEvent;
	CLocalEvent m_cResumeEvent;
	CLocalEvent m_cBreakEvent;
	volatile bool m_bKillSignal;

	CMediaData m_TsStream;

	bool m_bIsPlaying;
//	DWORD m_dwLastError;

	int m_StreamThreadPriority;
};
