#pragma once

#include <set>
#include <vector>
#include "MediaDecoder.h"
#include "TsStream.h"

// TS̉͂CTsAnalyzergp
#define USE_TSANALYZER 0	// ₽ƃHĤŎgpȂ

// ŒlŋK肳ĂPIDIIɒʉ߂邽߂̊gp
#define USE_STATICPASS 0	// ̂Ƃ͖gp

#if USE_TSANALYZER
#include "TsAnalyzer.h"
#else

// CTsAnalyzerȂĂ̒xŏ\
// PMTpPbgȈՉ̓NX
class CTsPmtPacket
{
public:
	struct STPid
	{
	public:
		STPid(void) : m_byteType( 0 ), m_wPid( 0 ) {}
		BYTE m_byteType;
		WORD m_wPid;
	};
	CTsPmtPacket(void);
//	CTsPmtPacket( CTsPacket* t_pcTsPacket );
	virtual ~CTsPmtPacket();

	// TSpPbgZbg
	virtual void StorePacket( CTsPacket* t_pcTsPacket );

	// PMT PID擾
	virtual WORD GetPmtPid(void);

	// PCR PID擾
	virtual WORD GetPcrPid(void);

	// ES PID̃TCY(ނ̐)
	virtual size_t GetEsPidSize(void);

	// ES PID擾
	virtual STPid& GetEsPid( INT32 t_nIndex );

protected:
	WORD m_wPmtPid;
	WORD m_wPcrPid;
	std::vector< STPid > m_stPids;
};

#endif

// TSpPbg ZOtB^[
#if USE_TSANALYZER
class CTs1segFilter : public CTsAnalyzer
#else
class CTs1segFilter : public CMediaDecoder
#endif
{
public:
	CTs1segFilter(IEventHandler *pEventHandler = NULL);
	virtual ~CTs1segFilter();

// CMediaDecoder
	virtual void Reset();
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

private:
	// ʉ߂PID
	std::set< WORD > m_wDynamicPassTable;
#if USE_STATICPASS
	std::set< WORD > m_wStaticPassTable;
#endif
};
